#!/usr/bin/env perl

#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
# This file is part of G-language Genome Analysis Environment package
#
#     Copyright (C) 2001 - 2002 Keio University
#:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
# 
#   $Id: Cap3.pm,v 1.2 2002/05/28 10:06:19 gaou Exp $
#
# G-language GAE is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# G-language GAE is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with G-language GAE -- see the file COPYING.
# If not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#END_HEADER
#

package G::Tools::Cap3;

use SubOpt;
use G::Tools::PBS;
use G::Messenger;
use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter AutoLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(

   _cap3

	     );
$VERSION = '0.01';

#::::::::::::::::::::::::::::::
#        Methods Start
#::::::::::::::::::::::::::::::

sub new{
    my $pkg = shift;
    my $filename = shift;
    my $option = shift;
    my $this;

    return($this);
}

sub _cap3{  
    &opt_default(qsub=>'off',input=>"file",output=>"STDOUT");
    my @param;
    my @tmp;
    
    foreach(@_){
        if(/[abcdefgmnopsuvx]\=\d/){
	    push(@param,$_);
        }
        else{
            push(@tmp,$_);
        }
    }
    @_=@tmp;
    
    my @args=opt_get(@_);
    
    my $qsub=&opt_val("qsub");
    my $input=&opt_val("input");
    my $output=&opt_val("output");
    my $data;
    my $file;
    my $seq;
    my %opt;
    my $param;
    my $num;
    my $output_file=();
    $output_file = "> ".$output if($output ne "STDOUT");

    $data=shift @args;

    if($input eq 'seq'){
	$seq=shift @args;
	opendir(DIR,'/home/s99814tm/tmp/');
	@tmp=readdir(DIR);
	$num=$#tmp+1+time;
	@tmp=keys(%$seq);
	open(FILE,'>/home/s99814tm/tmp/cap3_'.$num.'.seq');
	print FILE ">$tmp[0]\n";
	print FILE $$seq{"$tmp[0]"},"\n";
	close(FILE);
	$file='/home/s99814tm/tmp/cap3_'.$num.'.seq'; 
    }
    else{
	$file=shift @args;
    }

    $opt{a}=&opt_val("a");
    $opt{b}=&opt_val("b");
    $opt{c}=&opt_val("c");
    $opt{d}=&opt_val("d");
    $opt{e}=&opt_val("e");
    $opt{f}=&opt_val("f");
    $opt{g}=&opt_val("g");
    $opt{m}=&opt_val("m");
    $opt{n}=&opt_val("n");
    $opt{o}=&opt_val("o");
    $opt{p}=&opt_val("p");
    $opt{s}=&opt_val("s");
    $opt{u}=&opt_val("u");
    $opt{v}=&opt_val("v");
    $opt{x}=&opt_val("x");

    foreach(sort keys(%opt)){
	next if($opt{$_} eq '');
	push(@param,$_.'=');
	push(@param,$opt{$_});
    }
    $param=join(' ',@param);

    msg_send("data= ",$data,"\n");
    msg_send("file= ",$file,"\n");
    msg_send("param= ",$param,"\n");
    msg_send("output= ",$output_file,"\n");

    system("/pub/software/cap3 $data $file $param $output_file")if($qsub eq "off");
   &qsub("/pub/software/cap3 $file $param $output_file")if($qsub eq "on");

    unlink('/home/s99814tm/tmp/cap3'.$num.'.seq') if($input eq 'seq' && $qsub ne 'on');

    return ("$data $file $param");

}

sub DESTROY {
    my $self = shift;
}

1;


__END__






